<template>
  <div class="profile">
    <div class="profile__info">
      <v-avatar size="100" class="profile__avatar">
        <img
          :src="avatar"
          alt="Avatar"
        />
      </v-avatar>
      <div class="profile__info-right">
        <div class="full-pic__info__owner">
          {{ name }}
        </div>
        <div class="profile__info-right__send-req">
          <v-btn
            v-if="!userFriends.includes($route.params.userID)"
            text
            outlined
            @click="addNewFriend">
            + Friend
          </v-btn>
          <v-btn
            v-else
            text
            outlined
            @click="deleteFriend">
            Friend
          </v-btn>
        </div>
      </div>
    </div>
    <Gallery :owner="$route.params.userID" />
  </div>
</template>

<script>
import Gallery from '../components/Gallery'
import { GetUser, AddFriend, DeleteFriend } from '@/api/users'
import { newAvatarS3Link } from '@/js/s3'
import { mapGetters, mapMutations } from 'vuex'

export default {
  name: 'Profile',

  components: {
    Gallery
  },

  data() {
    return {
      name: '',
      avatar: ''
    }
  },

  computed: {
    ...mapGetters([
      'userFriends',
      'userID'
    ])
  },

  methods: {
    ...mapMutations([
      'addUserFriend',
      'deleteUserFriend'
    ]),

    async addNewFriend() {
      const status = await AddFriend(this.userID, this.$route.params.userID)
      if (!status) {
        return
      }

      if (status === 200) {
        this.$toasted.success('Request sent')
        this.addUserFriend(this.$route.params.userID)
      } else {
        this.$toasted.error('Oh no... Something bad happened')
      }
    },

    async deleteFriend() {
      if (confirm("Do you really want to delete friend?")) {
        const status = await DeleteFriend(this.userID, this.$route.params.userID)
        if (!status) {
          return
        }

        if (status === 200) {
          this.deleteUserFriend(this.$route.params.userID)
        } else {
          this.$toasted.error('Oh no... Something bad happened')
        }
      }
    }
  },

  async created() {
    const response = await GetUser(this.$route.params.userID)
    if (!response.status) {
      return
    }

    if (response.status !== 200) {
      this.$toasted.error('Oh no... Something bad happened')
      return
    }

    const user = response.data.data.data.attributes

    this.name = user.first_name + ' ' + user.last_name
    this.avatar = user.has_avatar ? newAvatarS3Link(this.$route.params.userID) : '/dummy.png'
  }
}
</script>

<style>
.profile__info {
  margin-left: 200px;
  margin-top: 25px;
  font-size: 30px;
  display: flex;
}

.profile__info-right__send-req {
  margin-left: 10px;
  color: rgba(51, 51, 51, 1);
  font-family: 'Nunito', fantasy;
  font-style: normal;
  font-weight: 400;
  font-size: 13px;
}
</style>
